/*  gb2jis (GuoBiao Hanzi to JIS Kanji converter) Version 1.4
			by Koichi Yasuoka, October 4, 1994 */

#include <stdio.h>
#ifndef UNDEFCHAR
#define UNDEFCHAR 0x2020
#endif
extern unsigned short *GB2312JX0208[],*GB2312JX0212[],*GB2312UZPJ[];
FILE *fp;
int HZ,JIS,UZPJ,KANJI,HANZI,ISATTY;

main(argc,argv)
int argc;
char *argv[];
{
  int i;
  HZ=JIS=UZPJ=KANJI=HANZI=0;
  ISATTY=isatty(1);
  while(argc>1){
    if(argv[1][0]!='-')
      break;
    for(i=1;argv[1][i]>0;i++){
      switch(argv[1][i]){
	case 'h':
	  HZ=1;
	  break;
	case 'j':
	  if(JIS==0)
	    JIS=1;
	  break;
	case 'e':
	  if(JIS==3){
	    fprintf(stderr,"gb2jis: option -s contradicts -e\n");
	    exit(2);
	  }
	  JIS=2;
	  break;
	case 's':
	  if(JIS==2){
	    fprintf(stderr,"gb2jis: option -e contradicts -s\n");
	    exit(2);
	  }
	  JIS=3;
	  break;
	case 'p':
	  UZPJ=1;
	  break;
	case 'i':
	  ISATTY=1;
	  break;
	default:
	  fprintf(stderr,"Usage: gb2jis [-hjespi] [file...]\n");
	  exit(2);
      }
    }
    argc--;
    argv++;
  }
  if(argc==1){
    fp=stdin;
    gb2jis();
    exit(0);
  }
  while(argc>1){
    if((fp=fopen(argv[1],"r"))==NULL)
      fprintf(stderr,"Cannot open %s\n",argv[1]);
    else{
      gb2jis();
      fclose(fp);
    }
    argc--;
    argv++;
  }
  exit(0);
}

gb2jis(){
  int h,l;
  while((l=hanzi())>=0){
    if(l<256)
      kanji0(l);
    else{
      h=(l>>8)-161;
      l=(l&255)-161;
      if(JIS==0&&GB2312JX0212[h][l]>0)
	kanji2(GB2312JX0212[h][l]);
      else if(UZPJ>0&&GB2312UZPJ[h][l]>0)
	kanji1(GB2312UZPJ[h][l]);
      else if(GB2312JX0208[h][l]>0)
	kanji1(GB2312JX0208[h][l]);
      else
	kanji1(UNDEFCHAR);
    }
    if(ISATTY)
      fflush(stdout);
  }
}

hanzi(){
  int i,j;
  while((i=fgetc(fp))>=0){
    if(HZ>0&&i=='~'){
      if((i=fgetc(fp))=='{'){
	HANZI=1;
	HZ=2;
	continue;
      }
      else if(i=='}'){
	HANZI=0;
	HZ=1;
	continue;
      }
      ungetc(i,fp);
      return('~');
    }
    else if(i==27){
      if((i=fgetc(fp))=='$'){
	if((i=fgetc(fp))=='A'){
	  HANZI=1;
	  continue;
	}
	else if(i=='('){
	  if((j=fgetc(fp))=='A'){
	    HANZI=1;
	    continue;
	  }
	  else if(j=='E'){
	    HANZI=1;
	    continue;
	  }
	  ungetc(j,fp);
        }
	HANZI=0;
        ungetc(i,fp);
	ungetc('$',fp);
      }
      else if(HANZI==1&&i=='('){
	HANZI=0;
	if((i=fgetc(fp))=='B')
	  continue;
	else if(i=='T')
	  continue;
	ungetc(i,fp);
	ungetc('(',fp);
      }
      else
	ungetc(i,fp);
      HANZI|=2;
      return(27);
    }
    else if(i>160&&i<255){
      j=fgetc(fp);
      if(j>160&&j<255)
	return((i<<8)+j);
      ungetc(j,fp);
    }
    else if(HANZI==1&&i>32&&i<127){
      j=fgetc(fp);
      if(j>32&&j<127)
	return((i<<8)+j+0x8080);
      ungetc(j,fp);
    }
    else if(HANZI>1&&(i<32||(i>='@'&&i<='Z')||(i>='a'&&i<='z')))
      HANZI&=1;
    else if(HZ==2&&i=='\n'){
      HANZI=0;
      HZ=1;
    }
    return(i);
  }
  return(-1);
}

kanji0(c)
int c;
{
  if(KANJI>0)
    printf("\033(B");
  putchar(c);
  KANJI=0;
}

kanji1(l)
int l;
{
  int h;
  if(JIS==2)
    printf("%c%c",l>>8,l&255);
  else if(JIS==3){
    if(l<0x8000)
      printf("%c%c",l>>8,l&255);
    else{
      h=(l+((l<0xdf00)?0x6100:0xe100))>>9;
      l=(l&255)-((l&256)?96:2);
      l-=(l<128);
      printf("%c%c",h,l);
    }
  }
  else if(l<0x8000){
    if(KANJI>0)
      printf("\033(B");
    if((l>>8)!='_')
      putchar(l>>8);
    putchar(l&127);
    KANJI=0;
  }
  else{
    if(KANJI!=1)
      printf("\033$B");
    printf("%c%c",(l>>8)&127,l&127);
    KANJI=1;
  }
}

kanji2(c)
int c;
{
  if(KANJI!=2)
    printf("\033$(D");
  printf("%c%c",(c>>8)&127,c&127);
  KANJI=2;
}

unsigned short nulltbl[]={
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
};
